import { APIGatewayProxyResult } from 'aws-lambda';
import { Headers, MultiValueHeaders, ResponseOverrides, Template, TransformationFn } from './types';
export declare class ResponseTemplate {
    headers: Headers;
    multiValueHeaders: MultiValueHeaders;
    isBase64Encoded?: boolean;
    transform?: TransformationFn;
    /** Creates a template. */
    constructor(template?: Template);
    /**
     * Creates a response object from a template.
     *
     * @param statusCode - HTTP status code.
     * @param body - The response body.
     * @param overrides - Override these parts of your template.
     * @param contentType - Set `Content-Type` header to this value.
     */
    make(statusCode: number, body?: any, overrides?: ResponseOverrides): APIGatewayProxyResult;
    make(statusCode: number, body?: any, contentType?: string): APIGatewayProxyResult;
}
